"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unifyModuleImport = exports.formatModuleImports = void 0;
var constants_1 = require("./constants");
function formatModuleImports(_a) {
    var moduleImports = _a.moduleImports, idToTypeName = _a.idToTypeName, idToFileName = _a.idToFileName;
    return moduleImports
        .map(function (moduleImport) {
        return formatModuleImport({ moduleImport: moduleImport, idToTypeName: idToTypeName, idToFileName: idToFileName });
    })
        .join('\n');
}
exports.formatModuleImports = formatModuleImports;
function formatModuleImport(args) {
    var _a = unifyModuleImport(args), path = _a.path, properties = _a.properties;
    return "import { " + properties.join(', ') + " } from '" + path + "';";
}
function unifyModuleImport(_a) {
    var moduleImport = _a.moduleImport, idToTypeName = _a.idToTypeName, idToFileName = _a.idToFileName;
    switch (moduleImport.type) {
        case 'internal':
            var typeName = idToTypeName(moduleImport.id);
            var moduleName = idToFileName(moduleImport.id).replace(/\.ts$/, '');
            var path = moduleImport.nested
                ? "./" + constants_1.TYPES_DIR + "/" + moduleName
                : "./" + moduleName;
            return {
                path: path,
                properties: [typeName],
            };
        case 'external':
            return {
                path: moduleImport.package,
                properties: moduleImport.properties,
            };
    }
}
exports.unifyModuleImport = unifyModuleImport;
