"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateContentfulTypes = void 0;
var promises_1 = require("fs/promises");
var ramda_1 = require("ramda");
var fetch_content_types_1 = require("./fetch-content-types");
var format_1 = require("./format");
var import_1 = require("./import");
var transform_1 = require("./transform");
function generateContentfulTypes(config) {
    return __awaiter(this, void 0, void 0, function () {
        var outputDirectory, idToTypeName, idToFileName;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    outputDirectory = config.outputDirectory;
                    idToTypeName = format_1.idToTypeNameFactory(config);
                    idToFileName = format_1.idToFileNameFactory(config);
                    return [4 /*yield*/, Promise.all(Object.keys(config.contentfulSpaces).map(function (spaceName) { return __awaiter(_this, void 0, void 0, function () {
                            var spaceConfig, spaceDirectory, spaceTypesDirectory;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        spaceConfig = config.contentfulSpaces[spaceName];
                                        spaceDirectory = format_1.spaceToDirectoryName({
                                            spaceName: spaceName,
                                            outputDirectory: outputDirectory,
                                        });
                                        spaceTypesDirectory = format_1.spaceToTypesDirectoryName({
                                            spaceName: spaceName,
                                            outputDirectory: outputDirectory,
                                        });
                                        return [4 /*yield*/, promises_1.mkdir(spaceTypesDirectory, { recursive: true })];
                                    case 1:
                                        _a.sent();
                                        return [4 /*yield*/, generateContentTypesForSpace({
                                                spaceName: spaceName,
                                                spaceConfig: spaceConfig,
                                                spaceDirectory: spaceDirectory,
                                                spaceTypesDirectory: spaceTypesDirectory,
                                                idToTypeName: idToTypeName,
                                                idToFileName: idToFileName,
                                            })];
                                    case 2:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.generateContentfulTypes = generateContentfulTypes;
function generateContentTypesForSpace(_a) {
    var spaceName = _a.spaceName, spaceConfig = _a.spaceConfig, spaceDirectory = _a.spaceDirectory, spaceTypesDirectory = _a.spaceTypesDirectory, idToTypeName = _a.idToTypeName, idToFileName = _a.idToFileName;
    return __awaiter(this, void 0, void 0, function () {
        var contentTypes, tsModels;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, fetch_content_types_1.fetchContentTypes(spaceConfig)];
                case 1:
                    contentTypes = _b.sent();
                    tsModels = transform_1.transformContentTypes(contentTypes);
                    return [4 /*yield*/, Promise.all([
                            writeSpaceModel({
                                spaceName: spaceName,
                                tsModels: tsModels,
                                spaceDirectory: spaceDirectory,
                                idToTypeName: idToTypeName,
                                idToFileName: idToFileName,
                            }),
                            writeTsModels({
                                tsModels: tsModels,
                                spaceTypesDirectory: spaceTypesDirectory,
                                idToTypeName: idToTypeName,
                                idToFileName: idToFileName,
                            }),
                        ])];
                case 2:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function writeSpaceModel(_a) {
    var spaceName = _a.spaceName, tsModels = _a.tsModels, spaceDirectory = _a.spaceDirectory, idToTypeName = _a.idToTypeName, idToFileName = _a.idToFileName;
    return __awaiter(this, void 0, void 0, function () {
        var spaceModel, spaceModelImports, fileContents;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    spaceModel = format_1.formatSpaceModel({ spaceName: spaceName, tsModels: tsModels, idToTypeName: idToTypeName });
                    spaceModelImports = format_1.formatModuleImports({
                        moduleImports: import_1.getSpaceImports({ tsModels: tsModels, idToFileName: idToFileName }),
                        idToTypeName: idToTypeName,
                        idToFileName: idToFileName,
                    });
                    fileContents = format_1.formatFileContents({
                        type: spaceModel,
                        imports: spaceModelImports,
                    });
                    return [4 /*yield*/, promises_1.writeFile(format_1.spaceModelToFileName({ spaceName: spaceName, spaceDirectory: spaceDirectory, idToFileName: idToFileName }), fileContents)];
                case 1:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function writeTsModels(_a) {
    var tsModels = _a.tsModels, spaceTypesDirectory = _a.spaceTypesDirectory, idToTypeName = _a.idToTypeName, idToFileName = _a.idToFileName;
    return __awaiter(this, void 0, void 0, function () {
        var models;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    models = tsModels.map(function (tsModel) {
                        return format_1.formatTsModel({ tsModel: tsModel, idToTypeName: idToTypeName });
                    });
                    return [4 /*yield*/, Promise.all(ramda_1.zip(models, tsModels).map(function (_a) {
                            var model = _a[0], tsModel = _a[1];
                            return __awaiter(_this, void 0, void 0, function () {
                                var modelImports, fileContents, id;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            modelImports = format_1.formatModuleImports({
                                                moduleImports: import_1.getModelImports({ tsModel: tsModel, idToFileName: idToFileName }),
                                                idToTypeName: idToTypeName,
                                                idToFileName: idToFileName,
                                            });
                                            fileContents = format_1.formatFileContents({
                                                type: model,
                                                imports: modelImports,
                                            });
                                            id = tsModel.id;
                                            return [4 /*yield*/, promises_1.writeFile(format_1.tsModelToFileName({ id: id, spaceTypesDirectory: spaceTypesDirectory, idToFileName: idToFileName }), fileContents)];
                                        case 1:
                                            _b.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        }))];
                case 1:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    });
}
