"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypeImports = exports.getModelImports = void 0;
var module_import_1 = require("../types/module-import");
var optimize_imports_1 = require("./optimize-imports");
function getModelImports(_a) {
    var tsModel = _a.tsModel, idToFileName = _a.idToFileName;
    var modelImports = tsModel.fields.reduce(function (moduleImports, tsField) { return __spreadArrays(moduleImports, getTypeImports(tsField.type)); }, []);
    return optimize_imports_1.optimizeImports({ moduleImports: modelImports, idToFileName: idToFileName });
}
exports.getModelImports = getModelImports;
function getTypeImports(tsType) {
    switch (tsType.type) {
        case 'Asset':
        case 'EntryFields.Location':
            return [
                {
                    type: 'external',
                    package: module_import_1.Package.Contentful,
                    properties: [tsType.type.split('.')[0]],
                },
            ];
        case 'Entry':
            return __spreadArrays([
                {
                    type: 'external',
                    package: module_import_1.Package.Contentful,
                    properties: ['Entry'],
                }
            ], tsType.entryIds.map(function (id) { return ({
                type: 'internal',
                id: id,
                nested: false,
            }); }));
        case 'Document':
            return [
                {
                    type: 'external',
                    package: module_import_1.Package.ContentfulRichTextTypes,
                    properties: ['Document'],
                },
            ];
        case 'array':
            return __spreadArrays(getTypeImports(tsType.itemsType));
    }
    return [];
}
exports.getTypeImports = getTypeImports;
