"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupInternalImports = exports.groupExternalImports = exports.optimizeImports = void 0;
function optimizeImports(_a) {
    var moduleImports = _a.moduleImports, idToFileName = _a.idToFileName;
    var _b = moduleImports.reduce(function (acc, moduleImport) {
        switch (moduleImport.type) {
            case 'external':
                return __assign(__assign({}, acc), { externalImports: __spreadArrays(acc.externalImports, [moduleImport]) });
            case 'internal':
                return __assign(__assign({}, acc), { internalImports: __spreadArrays(acc.internalImports, [moduleImport]) });
        }
    }, {
        externalImports: [],
        internalImports: [],
    }), externalImports = _b.externalImports, internalImports = _b.internalImports;
    var groupedExternalImports = groupExternalImports(externalImports);
    var groupedInternalImports = groupInternalImports(internalImports);
    var sortedExternalImports = groupedExternalImports.sort(function (x, y) {
        return x.package.localeCompare(y.package);
    });
    var sortedInternalImports = groupedInternalImports.sort(function (x, y) {
        return idToFileName(x.id).localeCompare(idToFileName(y.id));
    });
    return __spreadArrays(sortedExternalImports, sortedInternalImports);
}
exports.optimizeImports = optimizeImports;
function groupExternalImports(moduleImports) {
    var packageImportsMap = moduleImports.reduce(function (acc, moduleImport) {
        var _a;
        var prevImport = acc[moduleImport.package];
        var properties = __spreadArrays((prevImport ? prevImport.properties : []), moduleImport.properties).filter(function (prop, i, arr) { return arr.indexOf(prop) === i; })
            .sort();
        return __assign(__assign({}, acc), (_a = {}, _a[moduleImport.package] = __assign(__assign(__assign({}, moduleImport), prevImport), { properties: properties }), _a));
    }, {});
    return Object.values(packageImportsMap);
}
exports.groupExternalImports = groupExternalImports;
function groupInternalImports(moduleImports) {
    var idImportsMap = moduleImports.reduce(function (acc, moduleImport) {
        var _a;
        return (__assign(__assign({}, acc), (_a = {}, _a[moduleImport.id] = moduleImport, _a)));
    }, {});
    return Object.values(idImportsMap);
}
exports.groupInternalImports = groupInternalImports;
