"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseConfig = void 0;
var fs_1 = require("fs");
var jsonschema_1 = require("jsonschema");
var env_1 = require("./env");
var config_json_1 = __importDefault(require("./types/config.json"));
function parseConfig(path) {
    if (path === void 0) { path = 'contentful-config.json'; }
    var buffer = fs_1.readFileSync(path);
    var config = JSON.parse(buffer.toString());
    jsonschema_1.validate(config, config_json_1.default, { throwError: true });
    return env_1.loadEnvVars(config);
}
exports.parseConfig = parseConfig;
