export interface TsModel {
    id: string;
    description: string;
    fields: TsField[];
}
export interface TsField {
    id: string;
    type: TsType;
    optional: boolean;
}
export declare type TsType = TsBasicType | TsEntryType | TsArrayType | TsEnumType;
export interface TsBasicType {
    type: 'string' | 'string | Date' | 'number' | 'boolean' | 'object' | 'Document' | 'Asset' | 'EntryFields.Location';
}
export interface TsEntryType {
    type: 'Entry';
    entryIds: string[];
}
export interface TsArrayType {
    type: 'array';
    itemsType: TsType;
}
export interface TsEnumType {
    type: 'enum';
    values: string[] | number[];
}
